/****************************************************************************/
/*	LCDyKEY I/F														*/
/*																			*/
/*	݌v 2001/01/16 by hamachan											*/
/*	LCDyKEY̓oXC^tF[XŃANZX							*/
/*	ʐR[h́AHTȊO̓T|[gς݁B								*/
/*	GXP[vV[PX͔ʃT|[gB									*/
/*                                  Copyright (C) 2003- by hamayan		    */
/****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <ctype.h>

#if 0
#include "itron.h"
#include "kernel.h"
#endif

#include "lcd.h"		/*̈ˑzׂɗpӂB*/
#include "escsequ.h"

void LcdWrite( int mode, unsigned char c );		/*̊֐ɂ͈ˑLׁAOQƂsB*/

static char EscapeSequence( char c, int *x, int *y );
static unsigned char GetTheCorrectAddress( int x, int y );
static void LCD_Refresh( void );
static void	CousorMove( int x, int y );

static char	LcdBuf[COLSIZE][ROWSIZE];	/*LCDp̕\obt@*/
static int	c_x,c_y;					/*obt@̃J[\ʒu*/

/********************************************************************/
/*	WAIT														*/
/*	1LOOP24VXeNbNB1000 * (__CPU_CLOCK__ / 24 / 1000000)		*/
/********************************************************************/
#ifndef __HOS_V4__itron_h__

static void wait1000u( void )
{
#define		LOOP_COUNT_1000		(1000 * __CPU_CLOCK__ / 24 /1000000)
	volatile int i = LOOP_COUNT_1000;

	for(; i > 0; i--){}
}

static void dly_tsk( int tim )
{
	for( ; tim > 0; tim-- ) wait1000u();
}

#else


#endif	/*__HOS_V4__itron_h__*/

/********************************************************************/
/*	XAYW琳AhX擾B							*/
/********************************************************************/
static unsigned char GetTheCorrectAddress( int x, int y )
{
	return x + (( y >= 3 ) ? 0x54 : ( y >= 2 ) ? 0x14 : ( y >= 1 ) ? 0x40 : 0x00);
}

/********************************************************************/
/*			refresh													*/
/*	ʍXV													*/
/********************************************************************/
static void LCD_Refresh( void )
{
	int 	row,col;

	CURSORHOME;		/*z[Ɉړ*/
	dly_tsk( 4 );	/*{1.64msA]TĂB*/

	for(col = 0; col < COLSIZE; col++)
	{
		LcdWrite( CMD_MODE, 0x80 + GetTheCorrectAddress( 0, col ) );	/*ݐAhXݒ*/
		for(row = 0; row < ROWSIZE; row++)
		{
			LcdWrite( DATA_MODE, LcdBuf[col][row] );	/*ꕶ*/
		}
	}
	CousorMove( c_x, c_y );
}

/********************************************************************/
/*			scrollUp												*/
/********************************************************************/
static void scrollUp( void )
{
	memcpy( LcdBuf[0], LcdBuf[1], ROWSIZE * (COLSIZE - 1) );
	memset( LcdBuf[ COLSIZE - 1 ], ' ', ROWSIZE );
	LCD_Refresh();		/*ʍXV*/
	CousorMove( c_x, COLSIZE - 1 );
}

/********************************************************************/
/*			scrollDown												*/
/********************************************************************/
static void scrollDown( void )
{
	int		i;

	for( i = COLSIZE - 1; i > 0; i-- )
		memcpy( LcdBuf[i], LcdBuf[i - 1], ROWSIZE );

	memset( LcdBuf[i], ' ', ROWSIZE );
	LCD_Refresh();		/*ʍXV*/
	CousorMove( c_x, 0 );
}

/********************************************************************/
/*	LCD_Putc														*/
/*	T|[gO̐R[h╶ƂEOFԂB			*/
/*	펞0ԂB												*/
/********************************************************************/
int LCD_Putc( char c )
{
	int 	row,col;

	row = c_x; col = c_y;
	/*GXP[vV[PXtB^[*/
	c = EscapeSequence( c, &row, &col );
	/*䕶̏*/
	switch ( c )
	{
		case 0 :	/*GXP[vV[PXtB^[瓮얳̎wB*/
			break;

		case BS :
			if( row == 0 && col == 0 ) break;	/*擪ɋ鎞͉ȂB*/
			if( --row < 0 )	/*CfbNX߂A*/
			{
				if( --col < 0 ) col = 0;
				for( row = ROWSIZE - 1; row > 0; row-- ) if( LcdBuf[ col ][ row ] != ' ' ) break;
			}
#if 0	/*{BŜ͑Õ̕NA͍s킸AJ[\̈ړ̂݁B*/
			LcdBuf[ col ][ row ] = ' ';	/*OXy[Xɕϊ*/
			LcdWrite( CMD_MODE, 0x80 + GetTheCorrectAddress( row, col ) );	/*ݐAhXݒ*/
			LcdWrite( DATA_MODE, ' ' );	/*ꕶ*/
#endif
			break;

		case VT :	/*TAB*/
			if(col == 0) scrollDown();
			else col--;
			break;

		case LF :	/*s*/
			if(col == (COLSIZE - 1)) scrollUp();
			else col++;
			break;

		case FF :	/*J[\ꕶEɈړB*/
			if( ++row >= ROWSIZE )
			{
				row = 0;	/*s̖[ɒB͎̍sɈړ邪A*/
				if(col == (COLSIZE - 1)) scrollUp();	/*ŏIsꍇAXN[AbvKvƂȂB*/
				else col++;
			}
			break;

		case HM :
			CURSORHOME;		/*J[\z[*/
			row = col = 0;
			dly_tsk( 4 );	/*{1.64msA]TĂB*/
			break;

		case CR :
			row = 0;		/*XJ[\̂ݐ擪Ɉړ*/
			break;

		case SB :
			CLEARDISPLAY;	/*ʂ̃NAƁA*/
			dly_tsk( 4 );	/*{1.64msA]TĂB*/
			CURSORHOME;		/*J[\z[*/
			dly_tsk( 4 );	/*{1.64msA]TĂB*/
			row = col = 0;
			memset( LcdBuf, ' ', LCDBUFFERSIZE );
			break;

		case HT :	/*ʓ|Ȃ̂ŁȀT|[gȂ*/
		case BL :	/*uU[̂T|[g͂Ȃ*/
			return EOF;

		default :			/*ȊO̕\*/
			if( (c >= ' ' && c <= 0x7f) || ((unsigned char)c >= 0xa1 && (unsigned char)c <= 0xff) )	/*LCDŕ\\ȕ̂ݏo*/
			{
				LcdWrite( CMD_MODE, 0x80 + GetTheCorrectAddress( row, col ) );	/*ݐAhXݒ*/
				LcdWrite( DATA_MODE, c );	/*ꕶ*/
				LcdBuf[ col ][ row++ ] = c;	/*obt@̈ɃRs[*/
				if( row >= ROWSIZE )
				{
					row = 0;
					if( ++col >= COLSIZE )
					{
						row = 0;
						col = COLSIZE - 1;
						scrollUp();
					}
				}
			}
			else return EOF;

			break;
	}

	CousorMove( row, col );

	return 0;
}

/********************************************************************/
/*			lcd puts												*/
/*	s͏ޕ												*/
/********************************************************************/
void LCD_Puts( char *str )
{
	while( *str ) LCD_Putc( *str++ );
}

/********************************************************************/
/*			lcd block write											*/
/*	s͏ޕ												*/
/********************************************************************/
void LCDBlockWrite( char *str )
{
	char *ptr = (char *)LcdBuf;

	while( *str ) *ptr++ = *str++;
	LCD_Refresh();		/*ʍXV*/
}

/********************************************************************/
/*			cousor move												*/
/*	J[\w肵ʒuɈړB								*/
/********************************************************************/
static void CousorMove( int x, int y )
{
	CURSORMOVE;
	c_x = x;
	c_y = y;
	LcdWrite( CMD_MODE, 0x80 + GetTheCorrectAddress( c_x, ( y < COLSIZE ) ? y : COLSIZE - 1 ) );	/*ݐAhXݒ*/
}

typedef	struct
{
	int		index;
	char	*code;
	int		*x;
	int		*y;
} ESCSubcommandPara;

/********************************************************************/
/*			Escape Sequence ʊ֐								*/
/********************************************************************/
static int NumGetFromParameter( char code[], int limit, int offset )
{
	int		i,num;

	for( i = offset,num = 0; i < limit; i++ )
	{
		if( isdigit( code[ i ] ) )
		{
			num *= 10;
			num += code[ i ] - '0';
		}
		else break;
	}
	return ( num == 0 ) ? 1 : num;
}

/********************************************************************/
/*			Escape Sequence (A)										*/
/*	ESC[pnA															*/
/*	J[\w萔ɈړBAAɒB͉ȂB*/
/*	codéA܂Ŏ荞񂾃GXP[vV[PXBxAy	*/
/*	AJ[\̈ړʒuB											*/
/*	߂lɂ0ԂB												*/
/********************************************************************/
static char EscapeSequence_A( ESCSubcommandPara *para )
{
	*(para->y) -= NumGetFromParameter( para->code, para->index - 1, 2 );	/*ws߂*/
	if( *(para->y) < 0 ) *(para->y) = 0;	/*ɒBĂ邩𒲂ׁABĂ鎞0B*/

	return 0;
}

/********************************************************************/
/*			Escape Sequence (B)										*/
/*	ESC[pnB															*/
/*	J[\w萔ɈړBAAɒB͉ȂB*/
/*	codéA܂Ŏ荞񂾃GXP[vV[PXBxAy	*/
/*	AJ[\̈ړʒuB											*/
/*	߂lɂ0ԂB												*/
/********************************************************************/
static char EscapeSequence_B( ESCSubcommandPara *para )
{
	*(para->y) += NumGetFromParameter( para->code, para->index - 1, 2 );	/*wsi߂B*/
	if( *(para->y) >= COLSIZE ) *(para->y) = COLSIZE - 1;	/*ɒBĂ邩𒲂ׁABĂ鎞͍őlB*/

	return 0;
}

/********************************************************************/
/*			Escape Sequence (C)										*/
/*	ESC[pnC															*/
/*	J[\w萔EɈړBAAɒB͉ȂB*/
/*	codéA܂Ŏ荞񂾃GXP[vV[PXBxAy	*/
/*	AJ[\̈ړʒuB											*/
/*	߂lɂ0ԂB												*/
/********************************************************************/
static char EscapeSequence_C( ESCSubcommandPara *para )
{
	*(para->x) += NumGetFromParameter( para->code, para->index - 1, 2 );	/*w萔i߂B*/
	if( *(para->x) >= ROWSIZE ) *(para->x) = ROWSIZE - 1;	/*ɒBĂ邩𒲂ׁABĂ鎞͍őlB*/

	return 0;
}

/********************************************************************/
/*			Escape Sequence (D)										*/
/*	ESC[pnD															*/
/*	J[\w萔ɈړBAAɒB͉ȂB*/
/*	codéA܂Ŏ荞񂾃GXP[vV[PXBxAy	*/
/*	AJ[\̈ړʒuB											*/
/*	߂lɂ0ԂB												*/
/********************************************************************/
static char EscapeSequence_D( ESCSubcommandPara *para )
{
	*(para->x) -= NumGetFromParameter( para->code, para->index - 1, 2 );	/*w萔߂B*/
	if( *(para->x) < 0 ) *(para->x) = 0;	/*ɒBĂ邩𒲂ׁABĂ鎞0B*/

	return 0;
}

/********************************************************************/
/*			Escape Sequence (H)										*/
/*	ESC[pl;pcH														*/
/*	J[\wʒuɈړB									*/
/*	codéA܂Ŏ荞񂾃GXP[vV[PXBxAy	*/
/*	AJ[\̈ړʒuB											*/
/*	߂lɂ́AKvȂΐR[hԂÅ֐ŏ	*/
/*	Ă܂0ԂB											*/
/********************************************************************/
static char EscapeSequence_H( ESCSubcommandPara *para )
{
	int		i,pl,pc,*ptr;

	para->index -= 1;
	for( i = 2,ptr = &pl,pl = pc = 0; i < para->index; i++ )
	{
		if( isdigit( para->code[ i ] ) )
		{
			*ptr *= 10;
			*ptr += para->code[ i ] - '0';
		}
		else ptr = &pc;
	}
	*(para->x) = pl;
	*(para->y) = pc;

	return 0;
}

/********************************************************************/
/*			Escape Sequence (J)										*/
/*	ESC[?J															*/
/*	?0̎̓J[\ʒuʂ̏I܂ŃNAB			*/
/*	?1͉̎ʂ̏߂J[\ʒu܂ŃNAB			*/
/*	?2͉̎ʑSNAB								*/
/*	0,1̓J[\̈ړ͖B2͂́[ɈړB					*/
/*	߂lɂ́A0,1̏ꍇÅ֐ŏׂ0ԂB*/
/*	2̏ꍇ́ASBԂB											*/
/********************************************************************/
static char EscapeSequence_J( ESCSubcommandPara *para )
{
	int		ret = 0;

	switch ( para->code[ 2 ] )
	{
		case 'J' :	/*J[\ʒuʂ̏I܂ŃNAB*/
		case '0' :	/*J[\ʒuʂ̏I܂ŃNAB*/
			memset( (char *)LcdBuf + (*(para->y) * ROWSIZE) + *(para->x), ' ', LCDBUFFERSIZE - (*(para->y) * ROWSIZE) + *(para->x) );
			LCD_Refresh();		/*ʍXV*/
			break;
		case '1' :	/*ʂ̏߂J[\ʒu܂ŃNAB*/
			memset( (char *)LcdBuf, ' ', (*(para->y) * ROWSIZE) + *(para->x) );
			LCD_Refresh();		/*ʍXV*/
			break;
		case '2' :	/*ʑSNA*/
			ret = SB;
			break;
		default :
			break;
	}

	return ret;
}

/********************************************************************/
/*			Escape Sequence (K)										*/
/*	ESC[?K															*/
/*	?0̎̓J[\ʒuE[܂ŃNAB					*/
/*	?1͍̎[J[\ʒu܂ŃNAB					*/
/*	?2̎̓J[\sNAB								*/
/*	SăJ[\̈ړ͖B										*/
/*	߂lɂ́Å֐ŏׂ0ԂB			*/
/********************************************************************/
static char EscapeSequence_K( ESCSubcommandPara *para )
{
	switch ( para->code[ 2 ] )
	{
		case 'K' :	/*J[\ʒuE[܂ŃNA*/
		case '0' :	/*J[\ʒuE[܂ŃNA*/
			memset( (char *)LcdBuf + (*(para->y) * ROWSIZE) + *(para->x), ' ', ROWSIZE - *(para->x) );
			LCD_Refresh();		/*ʍXV*/
			break;
		case '1' :	/*J[\ʒu獶[܂ŃNA*/
			memset( (char *)LcdBuf + (*(para->y) * ROWSIZE), ' ', *(para->x) );
			LCD_Refresh();		/*ʍXV*/
			break;
		case '2' :	/*J[\sNA*/
			memset( (char *)LcdBuf + (*(para->y) * ROWSIZE), ' ', ROWSIZE );
			LCD_Refresh();		/*ʍXV*/
			break;
		default :
			break;
	}

	return 0;
}

/********************************************************************/
/*			Escape Sequence (l)										*/
/*	ESC[>?l															*/
/*	?5̎̓J[\LɂB								*/
/*	ȊÕp[^[͈ؖB							*/
/*	J[\̈ړ͖B											*/
/*	߂lɂ0ԂB												*/
/********************************************************************/
static char EscapeSequence_l( ESCSubcommandPara *para )
{
	if( para->code[2] == '>' && para->code[3] == '5' ) BLINKON;

	return 0;
}

/********************************************************************/
/*			Escape Sequence (h)										*/
/*	ESC[>?h															*/
/*	?5̎̓J[\𖳌ɂB								*/
/*	ȊÕp[^[͈ؖB							*/
/*	J[\̈ړ͖B											*/
/*	߂lɂ0ԂB												*/
/********************************************************************/
static char EscapeSequence_h( ESCSubcommandPara *para )
{
	if( para->code[2] == '>' && para->code[3] == '5' ) BLINKOFF;

	return 0;
}

/********************************************************************/
/*			Escape Sequence											*/
/*	c͓̓f[^Axy̓J[\̕ϐB					*/
/*	߂l͐R[hB											*/
/********************************************************************/
static char EscapeSequence( char c, int *x, int *y )
{
	static char	code[16];
	static int	index = 0;
	int		ret = 0;	/*߂l*/
	ESCSubcommandPara para;

	if( index == 0 )
	{
		if( c == ESC )		/*ESCôŁAGXP[vV[PXɓB*/
		{
			code[ 0 ] = c;
			index = 1;
			ret = 0;			/*̊֐ȍ~AȂĂB*/
		}
		else
			ret = c;			/*GXP[vV[PXɂ͓ĂȂ̂ŁÂ܂ܕԂB*/
	}
	else					/*2[vڈȍ~̏*/
	{
		code[ index++ ] = c;
		switch ( code[ 1 ] )
		{
			case '[' :		/*̌XɃp[^[B*/
				if( isalpha( c ) )	/*At@xbgoė́Af~^ƔfB*/
				{
					para.index = index;
					para.code = code;
					para.x = x;
					para.y = y;
					switch ( c )
					{
						case 'A' :
							ret = EscapeSequence_A( &para );
							break;
						case 'B' :
							ret = EscapeSequence_B( &para );
							break;
						case 'C' :
							ret = EscapeSequence_C( &para );
							break;
						case 'D' :
							ret = EscapeSequence_D( &para );
							break;
						case 'H' :
							ret = EscapeSequence_H( &para );
							break;
						case 'J' :
							ret = EscapeSequence_J( &para );
							break;
						case 'K' :
							ret = EscapeSequence_K( &para );
							break;
						case 'h' :
							ret = EscapeSequence_h( &para );
							break;
						case 'l' :
							ret = EscapeSequence_l( &para );
							break;
						default :
							ret = 0;
							break;
					}
					index = 0;
				}
				else ret = 0;
				break;

			case '=' :		/*J[\ʒüړBAl̋@\LׂɃT|[g͂ȂB*/
				if( index > 3 ) index = 0;	/*p[^[̏I܂ňsB*/
				ret = 0;
				break;
			case ')' :		/*AOtBbN[hɐ؂ւBAAT|[g͂ȂB*/
				if( index > 2 ) index = 0;	/*p[^[̏I܂ňsB*/
				ret = 0;
				break;
			case '*' :		/*ʃNA*/
				index = 0;
				ret = SB;
				break;
			case 'D' :		/*J[\sɈړ*/
				index = 0;
				ret = LF;
				break;
			case 'E' :		/*J[\s̍[Ɉړ*/
				index = 0;
				*x = 0;
				ret = LF;
				break;
			case 'M' :		/*J[\sɈړ*/
				index = 0;
				ret = VT;
				break;
			default :		/*T|[gR[h*/
				index = 0;
				ret = 0;
				break;
		}
	}

	return ret;
}

/****************************************************************************/
/*                                  Copyright (C) 2003- by hamayan		    */
/****************************************************************************/
